- Main Page
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# Ipopt::MumpsSolverInterface Class Reference

Interface to the linear solver Mumps, derived from SparseSymLinearSolverInterface. More...

`#include <IpMumpsSolverInterface.hpp>`

Inheritance diagram for Ipopt::MumpsSolverInterface:

[legend]
Collaboration diagram for Ipopt::MumpsSolverInterface:

[legend]
List of all members.

## Public Member Functions
bool | InitializeImpl (const OptionsList &options, const std::string &prefix)
| overloaded from AlgorithmStrategyObject
Constructor/Destructor
| MumpsSolverInterface ()
| Constructor.
virtual | ~MumpsSolverInterface ()
| Destructor.
Methods for requesting solution of the linear system.
virtual ESymSolverStatus | InitializeStructure (Index dim, Index nonzeros, const Index *ia, const Index *ja)
| Method for initializing internal stuctures.
virtual double * | GetValuesArrayPtr ()
| Method returing an internal array into which the nonzero elements are to be stored.
virtual ESymSolverStatus | MultiSolve (bool new_matrix, const Index *ia, const Index *ja, Index nrhs, double *rhs_vals, bool check_NegEVals, Index numberOfNegEVals)
| Solve operation for multiple right hand sides.
virtual Index | NumberOfNegEVals () const
| Number of negative eigenvalues detected during last factorization.
virtual bool | IncreaseQuality ()
| Request to increase quality of solution for next solve.
virtual bool | ProvidesInertia () const
| Query whether inertia is computed by linear solver.
EMatrixFormat | MatrixFormat () const
| Query of requested matrix type that the linear solver understands.
## Static Public Member Functions
static void | RegisterOptions (SmartPtr< RegisteredOptions > roptions)
| Methods for IpoptType.
## Private Member Functions
Default Compiler Generated Methods
(Hidden to avoid implicit creation/calling). These methods are not implemented and we do not want the compiler to implement them for us, so we declare them private and do not define them. This ensures that they will not be implicitly created/called.
| MumpsSolverInterface (const MumpsSolverInterface &)
| Copy Constructor.
void | operator= (const MumpsSolverInterface &)
| Overloaded Equals Operator.
Internal functions
ESymSolverStatus | Factorization (const Index *ia, const Index *ja, bool check_NegEVals, Index numberOfNegEVals)
| Call Mumps to factorize the Matrix.
ESymSolverStatus | Solve (const Index *ia, const Index *ja, Index nrhs, double *rhs_vals)
| Call Mumps to do the Solve.
## Private Attributes
DMUMPS_STRUC_C | mumps_data
Information about the matrix
Index | n
| Number of rows and columns of the matrix.
Index | nz
| Number of nonzeros of the matrix in triplet representation.
double * | a
| Array for storing the values of the matrix.
int * | irn_
| Array for storing the row indices of the matrix.
int * | jcn_
| Array for storing the column indices of the matrix.
Information about most recent factorization/solve
Index | negevals
| Number of negative eigenvalues.

## Detailed Description

Interface to the linear solver Mumps, derived from SparseSymLinearSolverInterface.

For details, see description of SparseSymLinearSolverInterface base class.

Definition at line 28 of file IpMumpsSolverInterface.hpp.

## Constructor & Destructor Documentation

Ipopt::MumpsSolverInterface::MumpsSolverInterface | ( |  | ) |

Constructor.

virtual Ipopt::MumpsSolverInterface::~MumpsSolverInterface | ( |  | ) | `[virtual]`

Destructor.

Ipopt::MumpsSolverInterface::MumpsSolverInterface | ( | const MumpsSolverInterface & |  | ) | `[private]`

Copy Constructor.

## Member Function Documentation

bool Ipopt::MumpsSolverInterface::InitializeImpl | ( | const OptionsList & | options,
|  | const std::string & | prefix |
| ) |  |  | `[virtual]`

overloaded from AlgorithmStrategyObject

Implements Ipopt::SparseSymLinearSolverInterface.

virtual ESymSolverStatus Ipopt::MumpsSolverInterface::InitializeStructure | ( | Index | dim,
|  | Index | nonzeros,
|  | const Index * | ia,
|  | const Index * | ja |
| ) |  |  | `[virtual]`

Method for initializing internal stuctures.

Implements Ipopt::SparseSymLinearSolverInterface.

virtual double* Ipopt::MumpsSolverInterface::GetValuesArrayPtr | ( |  | ) | `[virtual]`

Method returing an internal array into which the nonzero elements are to be stored.

Implements Ipopt::SparseSymLinearSolverInterface.

virtual ESymSolverStatus Ipopt::MumpsSolverInterface::MultiSolve | ( | bool | new_matrix,
|  | const Index * | ia,
|  | const Index * | ja,
|  | Index | nrhs,
|  | double * | rhs_vals,
|  | bool | check_NegEVals,
|  | Index | numberOfNegEVals |
| ) |  |  | `[virtual]`

Solve operation for multiple right hand sides.

Implements Ipopt::SparseSymLinearSolverInterface.

virtual Index Ipopt::MumpsSolverInterface::NumberOfNegEVals | ( |  | ) | const`[virtual]`

Number of negative eigenvalues detected during last factorization.

Implements Ipopt::SparseSymLinearSolverInterface.

virtual bool Ipopt::MumpsSolverInterface::IncreaseQuality | ( |  | ) | `[virtual]`

Request to increase quality of solution for next solve.

Implements Ipopt::SparseSymLinearSolverInterface.

virtual bool Ipopt::MumpsSolverInterface::ProvidesInertia | ( |  | ) | const`[inline, virtual]`

Query whether inertia is computed by linear solver.

Returns true, if linear solver provides inertia.

Implements Ipopt::SparseSymLinearSolverInterface.

Definition at line 78 of file IpMumpsSolverInterface.hpp.

EMatrixFormat Ipopt::MumpsSolverInterface::MatrixFormat | ( |  | ) | const`[inline, virtual]`

Query of requested matrix type that the linear solver understands.

Implements Ipopt::SparseSymLinearSolverInterface.

Definition at line 85 of file IpMumpsSolverInterface.hpp.

References Ipopt::SparseSymLinearSolverInterface::Triplet_Format.

static void Ipopt::MumpsSolverInterface::RegisterOptions | ( | SmartPtr< RegisteredOptions > | roptions | ) | `[static]`

Methods for IpoptType.

void Ipopt::MumpsSolverInterface::operator= | ( | const MumpsSolverInterface & |  | ) | `[private]`

Overloaded Equals Operator.

ESymSolverStatus Ipopt::MumpsSolverInterface::Factorization | ( | const Index * | ia,
|  | const Index * | ja,
|  | bool | check_NegEVals,
|  | Index | numberOfNegEVals |
| ) |  |  | `[private]`

Call Mumps to factorize the Matrix.

ESymSolverStatus Ipopt::MumpsSolverInterface::Solve | ( | const Index * | ia,
|  | const Index * | ja,
|  | Index | nrhs,
|  | double * | rhs_vals |
| ) |  |  | `[private]`

Call Mumps to do the Solve.

## Member Data Documentation

Index Ipopt::MumpsSolverInterface::n`[private]`

Number of rows and columns of the matrix.

Definition at line 117 of file IpMumpsSolverInterface.hpp.

Index Ipopt::MumpsSolverInterface::nz`[private]`

Number of nonzeros of the matrix in triplet representation.

Definition at line 120 of file IpMumpsSolverInterface.hpp.

double* Ipopt::MumpsSolverInterface::a`[private]`

Array for storing the values of the matrix.

Definition at line 123 of file IpMumpsSolverInterface.hpp.

int* Ipopt::MumpsSolverInterface::irn_`[private]`

Array for storing the row indices of the matrix.

Definition at line 126 of file IpMumpsSolverInterface.hpp.

int* Ipopt::MumpsSolverInterface::jcn_`[private]`

Array for storing the column indices of the matrix.

Definition at line 128 of file IpMumpsSolverInterface.hpp.

Index Ipopt::MumpsSolverInterface::negevals`[private]`

Number of negative eigenvalues.

Definition at line 133 of file IpMumpsSolverInterface.hpp.

DMUMPS_STRUC_C Ipopt::MumpsSolverInterface::mumps_data`[private]`

Definition at line 169 of file IpMumpsSolverInterface.hpp.

The documentation for this class was generated from the following file:

- /home/coin/SVN-release/Ipopt-3.2.1/Ipopt/src/Algorithm/LinearSolvers/IpMumpsSolverInterface.hpp